<?php
/**
*
* @author oxpus (Karsten Ude) webmaster@oxpus.net
* @package meeting mod installation package based on umil (c) 2008 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// The name of the mod to be displayed during installation.
$mod_name = 'MEETING_MOD';

/*
* The name of the config variable which will hold the currently installed version
* You do not need to set this yourself, UMIL will handle setting and updating the version itself.
*/
$version_config_name = 'meeting_version';

/*
* The language file which will be included when installing
* Language entries that should exist in the language file for UMIL (replace $mod_name with the mod's name you set to $mod_name above)
* $mod_name
* 'INSTALL_' . $mod_name
* 'INSTALL_' . $mod_name . '_CONFIRM'
* 'UPDATE_' . $mod_name
* 'UPDATE_' . $mod_name . '_CONFIRM'
* 'UNINSTALL_' . $mod_name
* 'UNINSTALL_' . $mod_name . '_CONFIRM'
*/
$language_file = 'mods/meeting_install';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You must use correct version numbering.  Unless you know exactly what you can use, only use X.X.X (replacing X with an integer).
* The version numbering must otherwise be compatible with the version_compare function - http://php.net/manual/en/function.version-compare.php
*/
$versions = array(
	'2.0.0'	=> array(
		'table_add' => array(
			array('phpbb_meeting_comment', array(
				'COLUMNS'		=> array(
					'comment_id'		=> array('UINT', NULL, 'auto_increment'),
					'meeting_id'		=> array('UINT', 0),
					'user_id'			=> array('INT:8', 0),
					'meeting_comment'	=> array('MTEXT_UNI', ''),
					'meeting_edit_time'	=> array('INT:11', 0),
					'approve'			=> array('BOOL', 0),
					'uid'				=> array('VCHAR:8', ''),
					'bitfield'			=> array('VCHAR:255', ''),
					'flags'				=> array('UINT:11', 0),
				),
				'PRIMARY_KEY'	=> 'comment_id',
				),
			),

			array('phpbb_meeting_data', array(
				'COLUMNS'		=> array(
					'meeting_id'			=> array('UINT', 0),
					'meeting_time'			=> array('INT:11', 0),
					'meeting_until'			=> array('INT:11', 0),
					'meeting_location'		=> array('VCHAR', ''),
					'meeting_subject'		=> array('STEXT_UNI', ''),
					'meeting_desc'			=> array('MTEXT_UNI', ''),
					'meeting_link'			=> array('VCHAR', ''),
					'meeting_places'		=> array('UINT:8', 0),
					'meeting_by_user'		=> array('UINT:8', 0),
					'meeting_edit_by_user'	=> array('UINT:8', 0),
					'meeting_start_value'	=> array('UINT:8', 0),
					'meeting_recure_value'	=> array('UINT:8', 0),
					'meeting_notify'		=> array('BOOL', 0),
					'meeting_guest_overall'	=> array('INT:8', 0),
					'meeting_guest_single'	=> array('INT:8', 0),
					'meeting_guest_names'	=> array('BOOL', 0),
					'uid'					=> array('CHAR:8', ''),
					'bitfield'				=> array('VCHAR', ''),
					'flags'					=> array('UINT:11', 0),
				),
				'PRIMARY_KEY'	=> 'meeting_id'
				),
			),

			array('phpbb_meeting_guestnames', array(
				'COLUMNS'		=> array(
					'meeting_id'	=> array('INT:8', 0),
					'user_id'		=> array('INT:8', 0),
					'guest_prename'	=> array('VCHAR', ''),
					'guest_name'	=> array('VCHAR', ''),
					),
				),
			),

			array('phpbb_meeting_user', array(
				'COLUMNS'		=> array(
					'meeting_id'		=> array('UINT', 0),
					'user_id'			=> array('INT:8', 0),
					'meeting_sure'		=> array('TINT:4', 0),
					'meeting_guests'	=> array('INT:8', 0),
					),
				),
			),

			array('phpbb_meeting_usergroup', array(
				'COLUMNS'		=> array(
					'meeting_id'	=> array('UINT', 0),
					'meeting_group'	=> array('INT:8', 0),
					),
				),
			),
		),

		'config_add' => array(
			array('meeting_notify', '1', true),
			array('meeting_user_delete', '0', true),
			array('meeting_user_delete_comments', '0', true),
			array('meeting_user_edit', '0', true),
			array('meeting_user_enter', '0', true),
		),

		'table_column_add' => array(
			array('phpbb_groups', 'group_meeting_create', array('TINT:1', 0)),
		),

		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'MEETING_ADMIN'),

			array('acp', 'MEETING_ADMIN', array(
				'module_basename' => 'meeting',
				'module_langname'=> 'MEETING_CONFIG',
				'module_mode' => 'config',
				'module_auth' => 'acl_a_meeting_config'),
			),
	
			array('acp', 'MEETING_ADMIN', array(
				'module_basename' => 'meeting',
				'module_langname'=> 'MEETING_ADD',
				'module_mode' => 'add',
				'module_auth' => 'acl_a_meeting_add'),
			),
	
			array('acp', 'MEETING_ADMIN', array(
				'module_basename' => 'meeting',
				'module_langname'=> 'MEETING_MANAGE',
				'module_mode' => 'manage',
				'module_auth' => 'acl_a_meeting_manage')
			),
		),

		'permission_add' => array(
			array('a_meeting_config', true),
			array('a_meeting_add', true),
			array('a_meeting_manage', true),
		),

		'permission_set' => array(
			array('ADMINISTRATORS', 'a_meeting_config', 'group'),
			array('ADMINISTRATORS', 'a_meeting_add', 'group'),
			array('ADMINISTRATORS', 'a_meeting_manage', 'group'),
		),
	),

	'2.0.1'	=> array(),

	'2.0.2'	=> array(
		'config_add' => array(
			array('meeting_sign_perm', '3', true),
		),
	),

	'2.0.3'	=> array(),
	'2.0.4'	=> array(),
	'2.0.5'	=> array(),
	'2.0.6'	=> array(),
	'2.0.7'	=> array(),
	'2.0.8'	=> array(),
	'2.0.9'	=> array(),
	'2.0.10'	=> array(),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

?>